config/routes.rb
Rails.application.routes.draw do
  resources :vehicles, only: [:index, :new, :create, :edit, :update, :destroy]
  resources :dealerships, only: [:index, :new, :create, :edit, :update, :destroy]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/dealership.rb
class Dealership < ApplicationRecord
  has_many :vehicles

  validates :name, presence: true
end

app/models/vehicle.rb
class Vehicle < ApplicationRecord
  belongs_to :dealership

  validates :brand, :name, :model, :year, :dealership, presence: true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/dealerships_controller.rb
class DealershipsController < ApplicationController
  def index
    @dealerships = Dealership.all
  end

  def new
    @dealership = Dealership.new
  end

  def create
    @dealership = Dealership.new(dealership_params)

    if @dealership.save
      redirect_to dealerships_url
    else
      render :edit
    end
  end

  def edit
    @dealership = Dealership.find(params[:id])
  end

  def update
    @dealership = Dealership.find(params[:id])

    if @dealership.update(dealership_params)
      redirect_to dealerships_url
    else
      render :edit
    end
  end

  def destroy
    @dealership = Dealership.find(params[:id])

    @dealership.destroy

    redirect_to dealerships_url
  end

  private

  def dealership_params
    params.require(:dealership).permit(:name)
  end
end

app/controllers/vehicles_controller.rb
class VehiclesController < ApplicationController
  def index
    @vehicles = Vehicle.all
  end

  def new
    @vehicle = Vehicle.new
  end

  def create
    @vehicle = Vehicle.new(vehicle_params)

    @vehicle.dealership = Dealership.last
    if @vehicle.save
      redirect_to vehicles_url
    else
      render :new
    end
  end

  def edit
    @vehicle = Vehicle.find(params[:id])
  end

  def update
    @vehicle = Vehicle.find(params[:id])

    if @vehicle.update(vehicle_params)
      redirect_to vehicles_url
    else
      render :edit
    end
  end

  def destroy
    @vehicle = Vehicle.find(params[:id])

    @vehicle.destroy

    redirect_to vehicles_url
  end

  private

  def vehicle_params
    params.require(:vehicle).permit(:brand, :name, :model, :year, :comments)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/dealerships/_form.html.erb
<%= form_for(@dealership) do |f| %>
  <%= f.label :name %>
  <%= f.text_field :name %>

  <%= f.submit "Save" %>
<% end %>

app/views/dealerships/edit.html.erb
<%= render "form" %>

app/views/dealerships/index.html.erb
<h1>Dealerships</h1>

<%= link_to "New dealership", new_dealership_path %>

<ul>
  <% @dealerships.each do |dealership| %>
    <li>
      <div><%= dealership.name %></div>

      <div><%= link_to "Edit", edit_dealership_path(dealership) %></div>
      <div><%= link_to "Delete", dealership_path(dealership), data: { "turbo-method": :delete } %></div>
    </li>
  <% end %>
</ul>

app/views/dealerships/new.html.erb
<%= render "form" %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>DesafioAuth</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/vehicles/_form.html.erb
<%= form_for(@vehicle) do |f| %>
  <%= f.label :brand %>
  <%= f.text_field :brand %>

  <%= f.label :name %>
  <%= f.text_field :name %>

  <%= f.label :model %>
  <%= f.text_field :model %>

  <%= f.label :year %>
  <%= f.text_field :year %>

  <%= f.submit "Save" %>
<% end %>

app/views/vehicles/edit.html.erb
<%= render "form" %>

app/views/vehicles/index.html.erb
<h1>Vehicles</h1>

<%= link_to "New vehicle", new_vehicle_path %>

<ul>
  <% @vehicles.each do |vehicle| %>
    <li>
      <div><%= vehicle.brand %></div>
      <div><%= vehicle.name %></div>
      <div><%= vehicle.model %></div>
      <div><%= vehicle.year %></div>

      <div><%= link_to "Edit", edit_vehicle_path(vehicle) %></div>
      <div><%= link_to "Delete", vehicle_path(vehicle), data: { "turbo-method": :delete } %></div>
    </li>
  <% end %>
</ul>

app/views/vehicles/new.html.erb
<%= render "form" %>